

triolet = {};

function triolet.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations) and SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function triolet:load(xmlFile)
	self.currentFillType = Fillable.FILLTYPE_UNKNOWN
	
	
	self.objectInRange = triolet.objectInRange;

	
	
    self.lasttrioletArea = 0;
    self.trioletGroundFlag = self:getNextDirtyFlag();

	self.baleSearchNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.baleSearchNode#index"));
end;

function triolet:delete()
end;

function triolet:mouseEvent(posX, posY, isDown, isUp, button)
end;

function triolet:keyEvent(unicode, sym, modifier, isDown)
end;

function triolet:draw()
		
		if self.fillLevel > 0 then
            g_currentMission:addHelpButtonText(g_i18n:getText("reset"), InputBinding.reset);     
		end;	
		if self.currentFillType == Fillable.FILLTYPE_SILO or self.currentFillType == Fillable.FILLTYPE_SILAGE or self.currentFillType == Fillable.FILLTYPE_MAIZE or self.currentFillType == Fillable.FILLTYPE_CHAFF or self.currentFillType == Fillable.FILLTYPE_WHEAT or self.currentFillType == Fillable.FILLTYPE_BARLEY or self.currentFillType == Fillable.FILLTYPE_JOSERA or self.currentFillType == Fillable.FILLTYPE_POTATO then
			g_currentMission:addHelpButtonText(g_i18n:getText("convert"), InputBinding.convert);
		end;
  
end;

function triolet:update(dt)	
    if self:getIsActive() then		
		
		if self.currentFillType == Fillable.FILLTYPE_SILO then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_SILAGE then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_MAIZE then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_CHAFF then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_WHEAT then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_BARLEY then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;	
		end;
		if self.currentFillType == Fillable.FILLTYPE_JOSERA then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;			
		end;
		if self.currentFillType == Fillable.FILLTYPE_POTATO then
				if InputBinding.hasEvent(InputBinding.convert) then
                    self.currentFillType = Fillable.FILLTYPE_GRASS
				end;			
		end;	
		
		
		if InputBinding.hasEvent(InputBinding.reset) then
			self.currentFillType = Fillable.FILLTYPE_UNKNOWN;
			self.fillLevel = 0;
		end;

		if self.fillLevel == 0 and self.currentFillPlane ~= nil then
			for _, node in ipairs(self.currentFillPlane.nodes) do
				setVisibility(node.node, false);
		end;


end;

		end;
	end;


function triolet:updateTick()
 if self:getIsActive() then
					
					local bale = self:objectInRange(self.baleSearchNode);
					if bale ~= nil then
						baleId = networkGetObjectId(bale);
						bale = networkGetObject(baleId);
						if getUserAttribute(bale.nodeId, "isRoundbale") then
								if self.currentFillType == Fillable.FILLTYPE_UNKNOWN then
									self.fillLevel = 3000;
									self.currentFillType = Fillable.FILLTYPE_GRASS;
								end;
						end;
						
						bale:delete();
						if self.currentFillType == Fillable.FILLTYPE_GRASS then
							for _, node in ipairs(self.currentFillPlane.nodes) do
							setVisibility(node.node, true);
end;					end;
					end;
 end;
end;
	
	
function triolet:objectInRange(refNode)
    local nearestDistance = 1;
    local nearestBale = nil;
    local px, py, pz = getWorldTranslation(refNode);
	for index, item in pairs(g_currentMission.itemsToSave) do
	    itemNode = item.item.nodeId;
	    if getParent(item.item.nodeId) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundbale") or getUserAttribute(itemNode, "isHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = index;
					nearestBale = item.item;
					nearestObject = itemNode;
					nearestDistance = distance;
				end;
			end;
		end;
	end;	
    return nearestBale;
end;